# PASN_Integer Class Reference

Class for ASN Integer type. More...

`#include <asner.h>`

Inheritance diagram for PASN_Integer:

List of all members.

## Public Member Functions

| PASN_Integer (unsigned val=0)
| PASN_Integer (unsigned tag, TagClass tagClass, unsigned val=0)
PASN_Integer & | operator= (unsigned value)
| operator unsigned () const
unsigned | GetValue () const
void | SetValue (unsigned v)
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank.
virtual PObject * | Clone () const
| Create a copy of the class on the heap.
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream.
virtual void | SetConstraintBounds (ConstraintType type, int lower, unsigned upper)
virtual PString | GetTypeAsString () const
| Return a string giving the type of the object.
virtual PINDEX | GetDataLength () const
virtual PBoolean | Decode (PASN_Stream &)
virtual void | Encode (PASN_Stream &) const
PBoolean | DecodePER (PPER_Stream &strm)
void | EncodePER (PPER_Stream &strm) const
PBoolean | IsUnsigned () const

## Protected Attributes

unsigned | value

## Detailed Description

Class for ASN Integer type.

## Constructor & Destructor Documentation

PASN_Integer::PASN_Integer | ( | unsigned | val = `0` | ) |

PASN_Integer::PASN_Integer | ( | unsigned | tag,
|  | TagClass | tagClass,
|  | unsigned | val = `0` |
| ) |  |  |

## Member Function Documentation

virtual PObject* PASN_Integer::Clone | ( |  | ) | const`[virtual]`

Create a copy of the class on the heap.

The exact semantics of the descendent class determine what is required to make a duplicate of the instance. Not all classes can even do a clone operation.

The main user of the clone function is the `PDictionary` class as it requires copies of the dictionary keys.

The default behaviour is for this function to assert.

Returns:
  pointer to new copy of the class instance.

Reimplemented from PObject.

Reimplemented in PRFC1155_Counter, PRFC1155_Gauge, and PRFC1155_TimeTicks.

virtual Comparison PASN_Integer::Compare | ( | const PObject & | obj | ) | const`[virtual]`

Compare the two objects and return their relative rank.

This function is usually overridden by descendent classes to yield the ranking according to the semantics of the object.

The default function is to use the `CompareObjectMemoryDirect()` function to do a byte wise memory comparison of the two objects.

Returns:
  `LessThan`, `EqualTo` or `GreaterThan` according to the relative rank of the objects.

Reimplemented from PObject.

virtual PBoolean PASN_Integer::Decode | ( | PASN_Stream & |  | ) | `[virtual]`

Implements PASN_Object.

PBoolean PASN_Integer::DecodePER | ( | PPER_Stream & | strm | ) |

virtual void PASN_Integer::Encode | ( | PASN_Stream & |  | ) | const`[virtual]`

Implements PASN_Object.

void PASN_Integer::EncodePER | ( | PPER_Stream & | strm | ) | const

virtual PINDEX PASN_Integer::GetDataLength | ( |  | ) | const`[virtual]`

Implements PASN_Object.

virtual PString PASN_Integer::GetTypeAsString | ( |  | ) | const`[virtual]`

Return a string giving the type of the object.

Implements PASN_Object.

unsigned PASN_Integer::GetValue | ( |  | ) | const`[inline]`

PBoolean PASN_Integer::IsUnsigned | ( |  | ) | const

PASN_Integer::operator unsigned | ( |  | ) | const`[inline]`

PASN_Integer& PASN_Integer::operator= | ( | unsigned | value | ) |

Reimplemented in PRFC1155_Counter, PRFC1155_Gauge, and PRFC1155_TimeTicks.

virtual void PASN_Integer::PrintOn | ( | ostream & | strm | ) | const`[virtual]`

Output the contents of the object to the stream.

The exact output is dependent on the exact semantics of the descendent class. This is primarily used by the standard `operator<<` function.

The default behaviour is to print the class name.

Reimplemented from PObject.

virtual void PASN_Integer::SetConstraintBounds | ( | ConstraintType | type,
|  | int | lower,
|  | unsigned | upper |
| ) |  |  | `[virtual]`

Reimplemented from PASN_ConstrainedObject.

void PASN_Integer::SetValue | ( | unsigned | v | ) | `[inline]`

## Member Data Documentation

unsigned PASN_Integer::value `[protected]`

The documentation for this class was generated from the following file:

- asner.h